/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "exception.h"

enum class BockTrigger {
  // bock after equal points between re and contra
  equal_points,
  // bock after a lost solo game
  solo_lost,
  // bock after a lost re game (only re is announced)
  re_lost,
  // bock after a lost contra game (only contra is announced)
  contra_lost,
  // bock after a real heart trick
  heart_trick,
  // bock after a black game (a team got no trick)
  black
}; // enum class BockTrigger
constexpr BockTrigger bock_trigger_list[] = {
  BockTrigger::equal_points,
  BockTrigger::solo_lost,
  BockTrigger::re_lost,
  BockTrigger::contra_lost,
  BockTrigger::heart_trick,
  BockTrigger::black
};

string to_string(BockTrigger bock_trigger);
string gettext(BockTrigger bock_trigger);
ostream& operator<<(ostream& ostr, BockTrigger bock_trigger);
BockTrigger bock_trigger_from_string(string const& name);
