/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "exception.h"

enum class GameType {
  normal,
  thrown_nines,
  thrown_kings,
  thrown_nines_and_kings,
  thrown_richness,
  fox_highest_trump,
  redistribute,
  poverty,
  genscher,
  marriage,
  marriage_solo,
  marriage_silent,
  solo_meatless,
  solo_jack,
  solo_queen,
  solo_king,
  solo_queen_jack,
  solo_king_jack,
  solo_king_queen,
  solo_koehler,
  solo_club,
  solo_heart,
  solo_spade,
  solo_diamond,
}; // enum class GameType
constexpr GameType game_type_list[] = {
  GameType::normal,
  GameType::thrown_nines,
  GameType::thrown_kings,
  GameType::thrown_nines_and_kings,
  GameType::thrown_richness,
  GameType::fox_highest_trump,
  GameType::redistribute,
  GameType::poverty,
  GameType::genscher,
  GameType::marriage,
  GameType::marriage_solo,
  GameType::marriage_silent,
  GameType::solo_meatless,
  GameType::solo_jack,
  GameType::solo_queen,
  GameType::solo_king,
  GameType::solo_queen_jack,
  GameType::solo_king_jack,
  GameType::solo_king_queen,
  GameType::solo_koehler,
  GameType::solo_club,
  GameType::solo_heart,
  GameType::solo_spade,
  GameType::solo_diamond,
};

string to_string(GameType game_type) noexcept;
string gettext(GameType game_type);
ostream& operator<<(ostream& ostr, GameType game_type);
GameType game_type_from_string(string const& name);

bool is_with_unknown_teams(GameType game_type) noexcept;
bool is_normal(GameType game_type) noexcept;
bool is_poverty(GameType game_type) noexcept;
bool is_marriage(GameType game_type) noexcept;
bool is_solo(GameType game_type) noexcept;
bool is_real_solo(GameType game_type) noexcept;
bool is_color_solo(GameType game_type) noexcept;
bool is_picture_solo(GameType game_type) noexcept;
bool is_single_picture_solo(GameType game_type) noexcept;
bool is_double_picture_solo(GameType game_type) noexcept;
