/**********************************************************************
 *
 *   freedoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 ********************************************************************/

#include "constants.h"

#include "position.h"

/** -> result
 **
 ** @param    position   position
 **
 ** @return   name of the position
 **/
string
to_string(Position const position) noexcept
{
  switch (position) {
  case Position::north:
    return "north";
  case Position::south:
    return "south";
  case Position::east:
    return "east";
  case Position::west:
    return "west";
  case Position::center:
    return "center";
  } // switch (position)
  return {};
} // string to_string(Position position)

/** -> result
 **
 ** @param    position   position
 **
 ** @return   translation of the position
 **/
string
gettext(Position const position)
{
  return gettext("Position::" + to_string(position));
}

/** writes the gametype into the stream
 **
 ** @param    ostr       output stream
 ** @param    position   position
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, Position const position)
{ return (ostr << to_string(position)); }
