/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "exception.h"

enum class Team {
  noteam,
  re,
  contra, 
  unknown,
  maybe_re,   // Team for AI-Heuristics
  maybe_contra // Team for AI-Heuristics
}; // enum class Team
constexpr Team team_list[] = {
  Team::noteam,
  Team::re,
  Team::contra, 
  Team::unknown,
  Team::maybe_re,   // Team for AI-Heuristics
  Team::maybe_contra // Team for AI-Heuristics
};

string to_string(Team team) noexcept;
string short_string(Team team) noexcept;
string gettext(Team team);
ostream& operator<<(ostream& ostr, Team team);
Team team_from_string(string const& name);

/// converts team MAYBE_X to X
Team maybe_to_team(Team team) noexcept;
/// converts team X to MAYBE_X
Team team_to_maybe(Team team) noexcept;
Team opposite(Team team) noexcept;
// whether the team is 're' or 'contra'
bool is_real(Team team) noexcept;
