/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#include "constants.h"

#include "base.h"
#include "../gameplay_action.h"

namespace GameplayActions {

/**
 ** constructor
 **
 ** @param    line   line with the data
 **
 ** @return   -
 **/
template<Type t>
Base<t>::Base(string const& line) :
  GameplayAction()
{ }

/**
 ** -> result
 **
 ** @param    action   action to compare with
 **
 ** @return   -
 **/
template<Type t>
bool
Base<t>::equal(GameplayAction const& action) const
{
  return (this->type() == action.type());
} // bool Base<type>::equal(GameplayAction action) const

/**
 **
 ** writes the action in the output stream
 **
 ** @param	ostr	output stream
 **
 ** @return	-
 **/
template<Type t>
void
Base<t>::write(ostream& ostr) const
{
  ostr << this->type();
} // void Base::write(ostream& ostr) const

/**
 **
 ** writes the action in the output stream
 **
 ** @param	ostr	output stream
 **
 ** @return	-
 **/
template<Type t>
Type
Base<t>::type() const
{
  return t;
} // Type Base::type() const

/**
 ** -> result
 **
 ** @param	-
 **
 ** @return	a translation representing the data
 **/
template<Type t>
string
Base<t>::data_translation() const
{
  return {};
} // virtual string Base::data_translation() const

} // namespace GameplayActions
