/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#include "constants.h"

#include "check.h"

#include "../../utils/string.h"

namespace GameplayActions {

/** constructor
 **
 ** @param    line   line with the data
 **/
Check::Check(string const& line) :
  Base()
{
  auto const pre = to_string(this->type()) + " =";
  if (string(line, 0, pre.length()) != pre)
    return ;

  this->comment = string(line, pre.length());
  String::remove_blanks(this->comment);
} // Check::Check(string line)

/** writes the action in the output stream
 **
 ** @param    ostr   output stream
 **/
void
Check::write(ostream& ostr) const
{
  ostr << this->type();
  if (!this->comment.empty())
    ostr << " = " << this->comment;
} // void write(ostream& ostr) const

/** @return   a translation representing the data
 **/
string
Check::data_translation() const
{
  return this->comment;
} // string Check::data_translation() const

} // namespace GameplayActions

