/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "base.h"
#include "../../card/trick.h"

namespace GameplayActions {

using TrickOpen = Base<Type::trick_open>;
using TrickTaken = Base<Type::trick_taken>;

struct TrickFull : public Base<Type::trick_full> {
  TrickFull() = delete;
  explicit TrickFull(Trick const& trick);
  explicit TrickFull(string const& line);
  TrickFull(string const& line, istream& istr);

  ~TrickFull() override = default;

  bool equal(GameplayAction const& action) const override;

  void write(ostream& ostr) const override;

  string data_translation() const override;

  Trick trick;
}; // struct TrickFull : public Base<TRICK_FULL>

} // namespace GameplayActions
