/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

// included by players.h

#pragma once

class GamePlayers;

class GamePlayersIterator : public std::iterator<std::output_iterator_tag, GamePlayer> {
  friend class GamePlayers;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  GamePlayersIterator(GamePlayers& players, unsigned p) noexcept;

  public:
  GamePlayer& operator*() noexcept;
  GamePlayer const& operator*() const noexcept;
  GamePlayer* operator->() noexcept;
  GamePlayer const* operator->() const noexcept;
  GamePlayersIterator& operator++() noexcept;
  bool operator!=(GamePlayersIterator const& i) const noexcept;
  private:
  GamePlayers* const players_ = nullptr;
  unsigned p_ = 0;
}; // GamePlayersIterator 

class GamePlayersConstIterator : public std::iterator<std::output_iterator_tag, GamePlayer> {
  friend class GamePlayers;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  GamePlayersConstIterator(GamePlayers const& players, unsigned p) noexcept;

  public:
  GamePlayersConstIterator(GamePlayersIterator i) noexcept;
  GamePlayer const& operator*() const noexcept;
  GamePlayer const* operator->() const noexcept;
  GamePlayersConstIterator& operator++() noexcept;
  bool operator!=(GamePlayersConstIterator const& i) const noexcept;
  private:
  GamePlayers const* const players_ = nullptr;
  unsigned p_ = 0;
}; // GamePlayersConstIterator 
