/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

// included by tricks.h

#pragma once

class GameTricks;

class GameTricksIterator : public std::iterator<std::output_iterator_tag, Trick> {
  friend class GameTricks;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  GameTricksIterator(GameTricks& tricks, size_t p) noexcept;

  public:
  Trick& operator*();
  Trick const& operator*() const;
  Trick* operator->();
  Trick const* operator->() const;
  GameTricksIterator& operator++() noexcept;
  bool operator!=(GameTricksIterator const& i) const noexcept;

  private:
  GameTricks* const tricks_ = nullptr;
  size_t p_ = 0;
}; // GameTricksIterator 

class GameTricksConstIterator : public std::iterator<std::output_iterator_tag, Trick> {
  friend class GameTricks;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  GameTricksConstIterator(GameTricks const& tricks, size_t p) noexcept;

  public:
  GameTricksConstIterator(GameTricksIterator i);
  Trick const& operator*() const;
  Trick const* operator->() const;
  GameTricksConstIterator& operator++() noexcept;
  bool operator!=(GameTricksConstIterator const& i) const noexcept;

  private:
  GameTricks const* const tricks_ = nullptr;
  size_t p_ = 0;
}; // GameTricksConstIterator 
