/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

// included by players.h

#pragma once

class PartyPlayers;

class PartyPlayersIterator : public std::iterator<std::output_iterator_tag, PartyPlayer> {
  friend class PartyPlayers;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  PartyPlayersIterator() = delete;
  PartyPlayersIterator(PartyPlayers& players, unsigned p);

  public:
  PartyPlayer& operator*();
  PartyPlayer const& operator*() const;
  PartyPlayer* operator->();
  PartyPlayer const* operator->() const;
  PartyPlayersIterator& operator++();
  bool operator!=(PartyPlayersIterator const& i) const;
  private:
  PartyPlayers* const players_ = nullptr;
  unsigned p_ = 0;
}; // PartyPlayersIterator 

class PartyPlayersConstIterator : public std::iterator<std::output_iterator_tag, PartyPlayer> {
  friend class PartyPlayers;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  PartyPlayersConstIterator() = delete;
  PartyPlayersConstIterator(PartyPlayers const& players, unsigned p);

  public:
  PartyPlayer const& operator*() const;
  PartyPlayer const* operator->() const;
  PartyPlayersConstIterator& operator++();
  bool operator!=(PartyPlayersConstIterator const& i) const;
  private:
  PartyPlayers const* const players_ = nullptr;
  unsigned p_ = 0;
}; // PartyPlayersConstIterator 
