/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *   
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#include "constants.h"

#include "rule_types.h"

/** -> result
 **
 ** @param    type   rule type
 **
 ** @return   the name of 'type'
 **/
string
to_string(RuleType::Bool const type)
{
  switch(type) {
  case RuleType::mutate:
    return "mutate";
    (void)_("Rule::mutate");
  case RuleType::with_nines:
    return "with nines";
    (void)_("Rule::with nines");
  case RuleType::bock:
    return "bock";
    (void)_("Rule::bock");
  case RuleType::bock_append:
    return "append bock";
    (void)_("Rule::append bock");
  case RuleType::bock_120:
    return "bock after 120-120";
    (void)_("Rule::bock after 120-120");
  case RuleType::bock_solo_lost:
    return "bock after lost solo";
    (void)_("Rule::bock after lost solo");
  case RuleType::bock_re_lost:
    return "bock after lost re/contra";
    (void)_("Rule::bock after lost re/contra");
  case RuleType::bock_heart_trick:
    return "bock after heart trick";
    (void)_("Rule::bock after heart trick");
  case RuleType::bock_black:
    return "bock after black game";
    (void)_("Rule::bock after black game");
  case RuleType::throw_with_nines:
    return "throw with nines";
    (void)_("Rule::throw with nines");
  case RuleType::throw_with_kings:
    return "throw with kings";
    (void)_("Rule::throw with kings");
  case RuleType::throw_with_nines_and_kings:
    return "throw with nines and kings";
    (void)_("Rule::throw with nines and kings");
  case RuleType::throw_with_richness:
    return "throw with richness";
    (void)_("Rule::throw with richness");
  case RuleType::force_redistribute:
    return "force redistribute";
    (void)_("Rule::force redistribute");
  case RuleType::poverty:
    return "poverty";
    (void)_("Rule::poverty");
  case RuleType::poverty_shift:
    return "poverty shift";
    (void)_("Rule::poverty shift");
  case RuleType::poverty_shift_only_trump:
    return "poverty shift only trump";
    (void)_("Rule::poverty shift only trump");
  case RuleType::poverty_fox_do_not_count:
    return "poverty fox do not count";
    (void)_("Rule::poverty fox do not count");
  case RuleType::poverty_fox_shift_extra:
    return "poverty fox shift extra";
    (void)_("Rule::poverty fox shift extra");
  case RuleType::poverty_fox_shift_open:
    return "poverty fox shift open";
    (void)_("Rule::poverty fox shift open");
  case RuleType::throw_with_one_trump:
    return "throw with one trump";
    (void)_("Rule::throw with one trump");
  case RuleType::throw_when_fox_highest_trump:
    return "throw when fox highest trump";
    (void)_("Rule::throw when fox highest trump");
  case RuleType::marriage_first_foreign:
    return "marriage first foreign";
    (void)_("Rule::marriage first foreign");
  case RuleType::marriage_first_color:
    return "marriage first color";
    (void)_("Rule::marriage first color");
  case RuleType::marriage_first_single_color:
    return "marriage first single color";
    (void)_("Rule::marriage first single color");
  case RuleType::marriage_first_trump:
    return "marriage first trump";
    (void)_("Rule::marriage first trump");
  case RuleType::marriage_first_one_decides:
    return "marriage first one decides";
    (void)_("Rule::marriage first one decides");
  case RuleType::marriage_before_poverty:
    return "marriage before poverty";
    (void)_("Rule::marriage before poverty");
  case RuleType::genscher:
    return "genscher";
    (void)_("Rule::genscher");
  case RuleType::solo:
    return "solo";
    (void)_("Rule::solo");
  case RuleType::solo_jack:
    return "solo jack";
    (void)_("Rule::solo jack");
  case RuleType::solo_queen:
    return "solo queen";
    (void)_("Rule::solo queen");
  case RuleType::solo_king:
    return "solo king";
    (void)_("Rule::solo king");
  case RuleType::solo_queen_jack:
    return "solo queen jack";
    (void)_("Rule::solo queen jack");
  case RuleType::solo_king_jack:
    return "solo king jack";
    (void)_("Rule::solo king jack");
  case RuleType::solo_king_queen:
    return "solo king queen";
    (void)_("Rule::solo king queen");
  case RuleType::solo_koehler:
    return "solo koehler";
    (void)_("Rule::solo koehler");
  case RuleType::solo_color:
    return "solo color";
    (void)_("Rule::solo color");
  case RuleType::solo_meatless:
    return "solo meatless";
    (void)_("Rule::solo meatless");
  case RuleType::throwing_before_solo:
    return "throwing before solo";
    (void)_("Rule::throwing before solo");
  case RuleType::dollen:
    return "dollen";
    (void)_("Rule::dollen");
  case RuleType::dollen_second_over_first:
    return "dollen second over first";
    (void)_("Rule::dollen second over first");
  case RuleType::dollen_contrary_in_last_trick:
    return "dollen contrary in last trick";
    (void)_("Rule::dollen contrary in last trick");
  case RuleType::dollen_first_over_second_with_swines:
    return "dollen first over second with swines";
    (void)_("Rule::dollen first over second with swines");
  case RuleType::swines:
    return "swines";
    (void)_("Rule::swines");
  case RuleType::swines_announcement_begin:
    return "swines announcement begin";
    (void)_("Rule::swines announcement begin");
  case RuleType::swine_only_second:
    return "swine only second";
    (void)_("Rule::swine only second");
  case RuleType::swines_in_solo:
    return "swines in solo";
    (void)_("Rule::swines in solo");
  case RuleType::swines_in_poverty:
    return "swines in poverty";
    (void)_("Rule::swines in poverty");
  case RuleType::hyperswines:
    return "hyperswines";
    (void)_("Rule::hyperswines");
  case RuleType::hyperswines_announcement_begin:
    return "hyperswines announcement begin";
    (void)_("Rule::hyperswines announcement begin");
  case RuleType::hyperswines_in_solo:
    return "hyperswines in solo";
    (void)_("Rule::hyperswines in solo");
  case RuleType::hyperswines_in_poverty:
    return "hyperswines in poverty";
    (void)_("Rule::hyperswines in poverty");
  case RuleType::swines_and_hyperswines_joint:
    return "swines and hyperswines joint";
    (void)_("Rule::swines and hyperswines joint");
  case RuleType::extrapoint_catch_fox:
    return "extrapoint catch fox";
    (void)_("Rule::extrapoint catch fox");
  case RuleType::extrapoint_catch_fox_last_trick:
    return "extrapoint catch fox last trick";
    (void)_("Rule::extrapoint catch fox last trick");
  case RuleType::extrapoint_fox_last_trick:
    return "extrapoint fox last trick";
    (void)_("Rule::extrapoint fox last trick");
  case RuleType::extrapoint_double_fox_last_trick:
    return "extrapoint double fox last trick";
    (void)_("Rule::extrapoint double fox last trick");
  case RuleType::extrapoint_dolle_jabs_dolle:
    return "extrapoint dolle jabs dolle";
    (void)_("Rule::extrapoint dolle jabs dolle");
  case RuleType::extrapoint_heart_trick:
    return "extrapoint heart trick";
    (void)_("Rule::extrapoint heart trick");
  case RuleType::extrapoint_charlie:
    return "extrapoint charlie";
    (void)_("Rule::extrapoint charlie");
  case RuleType::extrapoint_catch_charlie:
    return "extrapoint catch charlie";
    (void)_("Rule::extrapoint catch charlie");
  case RuleType::extrapoint_double_charlie:
    return "extrapoint double charlie";
    (void)_("Rule::extrapoint double charlie");
  case RuleType::extrapoint_catch_double_charlie:
    return "extrapoint catch double charlie";
    (void)_("Rule::extrapoint catch double charlie");
  case RuleType::extrapoint_catch_charlie_only_with_diamond_queen:
    return "extrapoint catch charlie only with diamond queen";
    (void)_("Rule::extrapoint catch charlie only with diamond queen");
  case RuleType::knocking:
    return "knocking";
    (void)_("Rule::knocking");
  case RuleType::announcement_limit_only_for_current:
    return "announcement limit only for current";
    (void)_("Rule::announcement limit only for current");
  case RuleType::announcement_till_full_trick:
    return "announcement till full trick";
    (void)_("Rule::announcement till full trick");
  case RuleType::announcement_first_trick_thirty_points:
    return "announcement first trick thirty points";
    (void)_("Rule::announcement first trick thirty points");
  case RuleType::announcement_first_trick_thirty_points_only_first:
    return "announcement first trick thirty points only first";
    (void)_("Rule::announcement first trick thirty points only first");
  case RuleType::announcement_first_trick_thirty_points_only_re_contra:
    return "announcement first trick thirty points only re/contra";
    (void)_("Rule::announcement first trick thirty points only re/contra");
  case RuleType::announcement_first_trick_thirty_points_in_marriage:
    return "announcement first trick thirty points in marriage";
    (void)_("Rule::announcement first trick thirty points in marriage");
  case RuleType::announcement_reply:
    return "announcement reply";
    (void)_("Rule::announcement reply");
  case RuleType::announcement_strict_limit:
    return "announcement strict limit";
    (void)_("Rule::announcement strict limit");
  case RuleType::announcement_re_doubles:
    return "announcement re/contra doubles";
    (void)_("Rule::announcement re/contra doubles");
  case RuleType::announcement_contra_doubles_against_re:
    return "announcement contra doubles against re";
    (void)_("Rule::announcement contra doubles against re");
  case RuleType::number_of_rounds_limited:
    return "number of rounds limited";
    (void)_("Rule::number of rounds limited");
  case RuleType::points_limited:
    return "points limited";
    (void)_("Rule::points limited");
  case RuleType::offer_duty_solo:
    return "offer duty solo";
    (void)_("Rule::offer duty solo");
  case RuleType::lustsolo_player_leads:
    return "lustsolo player leads";
    (void)_("Rule::lustsolo player leads");
  case RuleType::solo_always_counts_triple:
    return "solo always counts triple";
    (void)_("Rule::solo always counts triple");
  } // switch(type)

  DEBUG_ASSERT(false);
  return {};
} // string to_string(RuleType::Bool type)

/** -> result
 **
 ** @param    type   rule type
 **
 ** @return   the name of 'type'
 **/
string
to_string(RuleType::Unsigned const type)
{
  switch(type) {
  case RuleType::bock_multiplier:
    return "bock multiplier";
    (void)_("Rule::bock multiplier");
  case RuleType::min_number_of_throwing_nines:
    return "min number of throwing nines";
    (void)_("Rule::min number of throwing nines");
  case RuleType::min_number_of_throwing_kings:
    return "min number of throwing kings";
    (void)_("Rule::min number of throwing kings");
  case RuleType::min_number_of_throwing_nines_and_kings:
    return "min number of throwing nines and kings";
    (void)_("Rule::min number of throwing nines and kings");
  case RuleType::min_richness_for_throwing:
    return "min richness for throwing";
    (void)_("Rule::min richness for throwing");
  case RuleType::marriage_determination:
    return "marriage determination";
    (void)_("Rule::marriage determination");
  case RuleType::announcement_no_120:
    return "announcement no 120";
    (void)_("Rule::announcement no 120");
  case RuleType::announcement_no_90:
    return "announcement no 90";
    (void)_("Rule::announcement no 90");
  case RuleType::announcement_no_60:
    return "announcement no 60";
    (void)_("Rule::announcement no 60");
  case RuleType::announcement_no_30:
    return "announcement no 30";
    (void)_("Rule::announcement no 30");
  case RuleType::announcement_no_0:
    return "announcement no 0";
    (void)_("Rule::announcement no 0");
  case RuleType::announcement_last:
    return "last announcement";
    (void)_("Rule::last announcement");
  case RuleType::number_of_rounds:
    return "number of rounds";
    (void)_("Rule::number of rounds");
  case RuleType::points:
    return "points";
    (void)_("Rule::points");
  case RuleType::number_of_duty_soli:
    return "number of duty soli";
    (void)_("Rule::number of duty soli");
  case RuleType::number_of_duty_color_soli:
    return "number of duty color soli";
    (void)_("Rule::number of duty color soli");
  case RuleType::number_of_duty_picture_soli:
    return "number of duty picture soli";
    (void)_("Rule::number of duty picture soli");
  case RuleType::number_of_players:
    return "number of players";
    (void)_("Rule::number of players");
  case RuleType::number_of_players_in_game:
    return "number of players in game";
    (void)_("Rule::number of players in game");
  } // switch(type)

  DEBUG_ASSERT(false);
  return {};
} // string to_string(RuleType::Unsigned type)

/** -> result
 **
 ** @param    type   rule type
 **
 ** @return   the name of 'type'
 **/
string
to_string(RuleType::UnsignedExtra const type)
{
  switch(type) {
  case RuleType::number_of_same_cards:
    return "number of same cards";
    (void)_("Rule::number of same cards");
  case RuleType::number_of_card_colors:
    return "number of card colors";
    (void)_("Rule::number of card colors");
  case RuleType::number_of_card_tcolors:
    return "number of card tcolors";
    (void)_("Rule::number of card tcolors");
  case RuleType::number_of_card_values:
    return "number of card values";
    (void)_("Rule::number of card values");
  case RuleType::number_of_cards:
    return "number of cards";
    (void)_("Rule::number of cards");
  case RuleType::number_of_teams:
    return "number of teams";
    (void)_("Rule::number of teams");
  case RuleType::number_of_players_per_team:
    return "number of players per team";
    (void)_("Rule::number of players per team");
  case RuleType::number_of_games_per_round:
    return "number of games per round";
    (void)_("Rule::number of games per round");
  case RuleType::max_number_of_tricks_in_game:
    return "maximal number of tricks in game";
    (void)_("Rule::maximal number of tricks in game");
  case RuleType::number_of_tricks_in_game:
    return "number of tricks in game";
    (void)_("Rule::number of tricks in game");
  case RuleType::points_for_doppelkopf:
    return "points for doppelkopf";
    (void)_("Rule::points for doppelkopf");
  case RuleType::max_number_of_poverty_trumps:
    return "max number of poverty trumps";
    (void)_("Rule::max number of poverty trumps");
  } // switch(type)

  DEBUG_ASSERTION(false,
                  "Rule::to_string(" << static_cast<int>(type) << ")\n"
                  "  type = " << static_cast<int>(type) << " not in switch");
  return {};
} // string to_string(RuleType::UnsignedExtra type)

/** -> result
 **
 ** @param    type   rule type
 **
 ** @return   the name of 'type'
 **/
string
to_string(RuleType::Counting const type)
{
  return "counting";
  (void)_("Rule::counting");
} // string to_string(RuleType::UnsignedExtra type)

/** -> result
 **
 ** @param    counting   the counting
 **
 ** @return   the name of 'counting'
 **/
string
to_string(Counting const counting)
{
  switch(counting) {
  case Counting::plus:
    return "plus";
    (void)_("Counting::plus");
  case Counting::minus:
    return "minus";
    (void)_("Counting::minus");
  case Counting::plusminus:
    return "plus-minus";
    (void)_("Counting::plus-minus");
  } // switch(counting)

  DEBUG_ASSERT(false);
  return {};
} // string to_string(Counting counting)

/** prints the name of 'type'
 **
 ** @param    ostr   output stream
 ** @param    type   type to print the name of
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, RuleType::Bool const type)
{
  ostr << to_string(type);

  return ostr;
} // ostream& operator<<(ostream& ostr, RuleType::Bool type)

/** prints the name of 'type'
 **
 ** @param    ostr   output stream
 ** @param    type   type to print the name of
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, RuleType::Unsigned const type)
{
  ostr << to_string(type);
  return ostr;
} // ostream& operator<<(ostream& ostr, RuleType::Unsigned type)

/** prints the name of 'type'
 **
 ** @param    ostr   output stream
 ** @param    type   type to print the name of
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, RuleType::UnsignedExtra const type)
{
  ostr << to_string(type);
  return ostr;
} // ostream& operator<<(ostream& ostr, RuleType::UnsignedExtra type)

/** prints the name of 'type'
 **
 ** @param    ostr   output stream
 ** @param    type   type to print the name of
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, RuleType::Counting type)
{
  ostr << to_string(type);
  return ostr;
} // ostream& operator<<(ostream& ostr, RuleType::Counting type)

/** prints the name of 'counting'
 **
 ** @param    ostr   output stream
 ** @param    counting   counting to print
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, Counting const counting)
{
  ostr << to_string(counting);
  return ostr;
} // ostream& operator<<(ostream& ostr, Counting counting)

/** @param    type   type
 **
 ** @return   translation of the type
 **/
string
gettext(RuleType::Bool const type)
{
  return gettext("Rule::" + to_string(type));
} // string gettext(RuleType::Bool type)

/** @param    type   type
 ** @param    text   text to append
 **
 ** @return   translation of the type
 **/
string
gettext(RuleType::Bool const type, string const& text)
{ return gettext("Rule::" + to_string(type)
                 + (text.empty() ? text : " -- " + text));
}

/** @param    type   type
 **
 ** @return   translation of the type
 **/
string
gettext(RuleType::Unsigned const type)
{
  return gettext("Rule::" + to_string(type));
} // string gettext(RuleType::Unsigned type)

/** @param    type   type
 ** @param    text   text to append
 **
 ** @return   translation of the type
 **/
string
gettext(RuleType::Unsigned const type, string const& text)
{
  return gettext("Rule::"
                 + to_string(type)
                 + (text.empty() ? text : " -- " + text));
} // string gettext(RuleType::Unsigned type, string text)

/** @param    type   type
 **
 ** @return   translation of the type
 **/
string
gettext(RuleType::Counting const type)
{
  return gettext("Rule::" + to_string(type));
} // string gettext(RuleType::Counting type)

/** @param    counting   counting
 **
 ** @return   translation of the type
 **/
string
gettext(Counting const counting)
{
  return gettext("Counting::" + to_string(counting));
} // string gettext(Counting counting)
