/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#include "heuristic.h"

class HeuristicRationale {
  public:
    HeuristicRationale() = default;
    HeuristicRationale(HeuristicRationale const&) = default;
    HeuristicRationale& operator=(HeuristicRationale const&) = default;

    operator string() const
    { return this->text_; }

    bool empty() const
    { return this->text_.empty(); }

    explicit operator bool() const
    { return !this->empty(); }

    string const& text() const
    { return this->text_; }

    void clear()
    { this->text_.clear(); }

    void add(string const text)
    {
      this->text_ += "– ";
      this->text_ += text;
      this->text_.push_back('\n');
    }
  private:
    string text_;
};

inline ostream& operator<<(ostream& ostr, HeuristicRationale const& reason)
{ return (ostr << reason.text()); }
inline bool operator!=(HeuristicRationale const& lhs, HeuristicRationale const& rhs)
{ return lhs.text() != rhs.text(); }
