/**********************************************************************
 *
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 ********************************************************************/

#include "constants.h"

#include "color_jab_for_ace.h"

#include "../../../../card/trick.h"

#include "../../ai.h"
#include "../../heuristics.h"

/** constructor
 **/
Heuristic::ColorJabForAce::ColorJabForAce(Ai const& ai) :
  Heuristic(ai, Aiconfig::Heuristic::color_jab_for_ace)
{ }

/** destructor
 **/
Heuristic::ColorJabForAce::~ColorJabForAce() = default;

/** @return  card to play or empty card
 **/
Card
Heuristic::ColorJabForAce::get_card(Trick const& trick)
{
  this->rationale_.clear();
  if (!this->condition_solo_color(trick))
    return {};

  return Heuristics::jab_for_ace(trick, *this->ai_);
}
