/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#include "weighting.h"

#include "../../card/hand.h"

class VirtualGamesInterface;
class Player;
class Trick;

// create for each card a virtual game and look, how many points the ai makes
class WVirtualGames : public Weighting {
  public:
    WVirtualGames() = delete;
    explicit WVirtualGames(Ai const& ai);
    WVirtualGames(WVirtualGames const&) = delete;
    WVirtualGames& operator=(WVirtualGames const&) = delete;

    ~WVirtualGames() override;

    unsigned future_limit() const;
    unsigned end_depth() const;

    // returns the weighting for the card 'card'
    int weighting(Card const& card) const override;


  private:
    // calculates the end depth
    void calculate_end_depth();

  private:
    unsigned future_limit_ = 0;
    unsigned end_depth_ = 0;
}; // class WVirtualGames : public Weighting
