/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#include "constants.h"

#include "ai_type.h"

/** -> result
 **
 ** @param    aitype   ai type
 **
 ** @return   the name of 'aitype'
 **/
string
to_string(AiType const aitype)
{
  switch(aitype) {
  case AiType::no_choosebestcard:
    return "no choosebestcard";
    (void)_("AiConfig::AiType::no choosebestcard");
  case AiType::random:
    return "random";
    (void)_("AiConfig::AiType::random");
  case AiType::virtual_games:
    return "virtual games";
    (void)_("AiConfig::AiType::virtual games");
  case AiType::gametree:
    return "gametree";
    (void)_("AiConfig::AiType::gametree");
  case AiType::gametree_with_heuristics:
    return "gametree with heuristics";
    (void)_("AiConfig::AiType::gametree with heuristics");
  case AiType::gametree_for_team:
    return "gametree for team";
    (void)_("AiConfig::AiType::gametree for team");
  case AiType::monte_carlo:
    return "monte carlo";
    (void)_("AiConfig::AiType::monte carlo");
  case AiType::monte_carlo_jab_or_serve:
    return "monte carlo - jab or serve";
    (void)_("AiConfig::AiType::monte carlo - jab or serve");
  } // switch(aitype)

  return "";
}

/** -> result
 **
 ** @param    name   name of the aitype
 **
 ** @return   the aitype
 **/
AiType
aitype_from_string(string const& name)
{
  for (auto const a : ai_type_list)
    if (to_string(a) == name)
      return a;
  throw name;
  return AiType::no_choosebestcard;
}

/** writes the aitype into the output stream
 **
 ** @param    ostr    output stream
 ** @param    aitype  aitype
 **
 ** @return   output stream
 **/
ostream&
operator<<(ostream& ostr, AiType const aitype)
{
  return (ostr << to_string(aitype));
}

/** @return   translation of the aitype
 **/
string
gettext(AiType aitype)
{
  return gettext("AiConfig::AiType::" + to_string(aitype));
}
