/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

enum class AiType {
  no_choosebestcard,
  random,
  virtual_games,
  gametree,
  gametree_with_heuristics,
  gametree_for_team,
  monte_carlo,
  monte_carlo_jab_or_serve
};

AiType constexpr ai_type_list[] = {
  AiType::no_choosebestcard,
  AiType::random,
  AiType::virtual_games,
  AiType::gametree,
  AiType::gametree_with_heuristics,
  AiType::gametree_for_team,
  AiType::monte_carlo,
  AiType::monte_carlo_jab_or_serve
};

AiType aitype_from_string(string const& name);

string to_string(AiType aitype);
string gettext(AiType aitype);
ostream& operator<<(ostream& ostr, AiType aitype);
