/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 ********************************************************************/

#include "constants.h"

#include "aiconfig_heuristic.h"


/** -> result
 **
 ** @param    heuristic   heuristic type
 **
 ** @return   the name of 'type'
 **/
string
to_string(AiconfigHeuristic const heuristic)
{
  switch(heuristic) {
  case AiconfigHeuristic::error:
    return "error";
  case AiconfigHeuristic::no_heuristic:
    return "no heuristic";
    (void)_("AiConfig::Heuristic::no heuristic");
    (void)_("AiConfig::Heuristic::Description::no heuristic");
  case AiconfigHeuristic::manual:
    return "manual";
    (void)_("AiConfig::Heuristic::manual");
    (void)_("AiConfig::Heuristic::Description::manual");
  case AiconfigHeuristic::bug_report:
    return "bug report";
    (void)_("AiConfig::Heuristic::bug report");
    (void)_("AiConfig::Heuristic::Description::bug report");
  case AiconfigHeuristic::only_valid_card:
    return "only valid card";
    (void)_("AiConfig::Heuristic::only valid card");
    (void)_("AiConfig::Heuristic::Description::only valid card");
  case AiconfigHeuristic::play_to_marry:
    return "play to marry";
    (void)_("AiConfig::Heuristic::play to marry");
    (void)_("AiConfig::Heuristic::Description::play to marry");
  case AiconfigHeuristic::play_to_get_married:
    return "play to get married";
    (void)_("AiConfig::Heuristic::play to get married");
    (void)_("AiConfig::Heuristic::Description::play to get married");
  case AiconfigHeuristic::choose_ace:
    return "choose ace";
    (void)_("AiConfig::Heuristic::choose ace");
    (void)_("AiConfig::Heuristic::Description::choose ace");
  case AiconfigHeuristic::choose_ten:
    return "choose ten";
    (void)_("AiConfig::Heuristic::choose ten");
    (void)_("AiConfig::Heuristic::Description::choose ten");
  case AiconfigHeuristic::choose_single_ace:
    return "choose single ace";
    (void)_("AiConfig::Heuristic::choose single ace");
    (void)_("AiConfig::Heuristic::Description::choose single ace");
  case AiconfigHeuristic::choose_for_color_trick:
    return "choose for color trick";
    (void)_("AiConfig::Heuristic::choose for color trick");
    (void)_("AiConfig::Heuristic::Description::choose for color trick");
  case AiconfigHeuristic::jab_color_over_fox:
    return "jab color over fox";
    (void)_("AiConfig::Heuristic::jab color over fox");
    (void)_("AiConfig::Heuristic::Description::jab color over fox");
  case AiconfigHeuristic::start_with_color:
    return "start with color";
    (void)_("AiConfig::Heuristic::start with color");
    (void)_("AiConfig::Heuristic::Description::start with color");
  case AiconfigHeuristic::start_with_low_color:
    return "start with low color";
    (void)_("AiConfig::Heuristic::start with low color");
    (void)_("AiConfig::Heuristic::Description::start with low color");
  case AiconfigHeuristic::start_with_low_trump:
    return "start with low trump";
    (void)_("AiConfig::Heuristic::start with low trump");
    (void)_("AiConfig::Heuristic::Description::start with low trump");
  case AiconfigHeuristic::retry_color:
    return "retry color";
    (void)_("AiConfig::Heuristic::retry color");
    (void)_("AiConfig::Heuristic::Description::retry color");
  case AiconfigHeuristic::play_color_for_partner:
    return "play color for partner";
    (void)_("AiConfig::Heuristic::play color for partner");
    (void)_("AiConfig::Heuristic::Description::play color for partner");
  case AiconfigHeuristic::try_color_for_partner:
    return "try color for partner";
    (void)_("AiConfig::Heuristic::try color for partner");
    (void)_("AiConfig::Heuristic::Description::try color for partner");
  case AiconfigHeuristic::play_color_for_partner_ace:
    return "play color for partner ace";
    (void)_("AiConfig::Heuristic::play color for partner ace");
    (void)_("AiConfig::Heuristic::Description::play color for partner ace");
  case AiconfigHeuristic::play_bad_color:
    return "play bad color";
    (void)_("AiConfig::Heuristic::play bad color");
    (void)_("AiConfig::Heuristic::Description::play bad color");
  case AiconfigHeuristic::jab_color_trick_with_dolle:
    return "jab color trick with dolle";
    (void)_("AiConfig::Heuristic::jab color trick with dolle");
    (void)_("AiConfig::Heuristic::Description::jab color trick with dolle");
  case AiconfigHeuristic::save_dolle:
    return "save dolle";
    (void)_("AiConfig::Heuristic::save dolle");
    (void)_("AiConfig::Heuristic::Description::save dolle");
  case AiconfigHeuristic::pfund_in_first_color_run:
    return "pfund in first color run";
    (void)_("AiConfig::Heuristic::pfund in first color run");
    (void)_("AiConfig::Heuristic::Description::pfund in first color run");
  case AiconfigHeuristic::serve_color_trick:
    return "serve color trick";
    (void)_("AiConfig::Heuristic::serve color trick");
    (void)_("AiConfig::Heuristic::Description::serve color trick");
  case AiconfigHeuristic::serve_trump_trick:
    return "serve trump trick";
    (void)_("AiConfig::Heuristic::serve trump trick");
    (void)_("AiConfig::Heuristic::Description::serve trump trick");
  case AiconfigHeuristic::choose_pfund:
    return "choose pfund";
    (void)_("AiConfig::Heuristic::choose pfund");
    (void)_("AiConfig::Heuristic::Description::choose pfund");
  case AiconfigHeuristic::choose_pfund_poverty:
    return "choose pfund poverty";
    (void)_("AiConfig::Heuristic::choose pfund poverty");
    (void)_("AiConfig::Heuristic::Description::choose pfund poverty");
  case AiconfigHeuristic::choose_pfund_before_partner:
    return "choose pfund before partner";
    (void)_("AiConfig::Heuristic::choose pfund before partner");
    (void)_("AiConfig::Heuristic::Description::choose pfund before partner");
  case AiconfigHeuristic::jab_for_ace:
    return "jab for ace";
    (void)_("AiConfig::Heuristic::jab for ace");
    (void)_("AiConfig::Heuristic::Description::jab for ace");
  case AiconfigHeuristic::create_fehl:
    return "create fehl";
    (void)_("AiConfig::Heuristic::create fehl");
    (void)_("AiConfig::Heuristic::Description::create fehl");
  case AiconfigHeuristic::best_winning:
    return "best winning card";
    (void)_("AiConfig::Heuristic::best winning card");
    (void)_("AiConfig::Heuristic::Description::best winning card");
  case AiconfigHeuristic::low_high:
    return "play low high";
    (void)_("AiConfig::Heuristic::play low high");
    (void)_("AiConfig::Heuristic::Description::play low high");
  case AiconfigHeuristic::play_trump:
    return "play trump";
    (void)_("AiConfig::Heuristic::play trump");
    (void)_("AiConfig::Heuristic::Description::play trump");
  case AiconfigHeuristic::play_for_team:
    return "play for team";
    (void)_("AiConfig::Heuristic::play for team");
    (void)_("AiConfig::Heuristic::Description::play for team");
  case AiconfigHeuristic::jab_fox:
    return "jab fox";
    (void)_("AiConfig::Heuristic::jab fox");
    (void)_("AiConfig::Heuristic::Description::jab fox");
  case AiconfigHeuristic::jab_for_doppelkopf:
    return "jab for doppelkopf";
    (void)_("AiConfig::Heuristic::jab for doppelkopf");
    (void)_("AiConfig::Heuristic::Description::jab for doppelkopf");
  case AiconfigHeuristic::try_for_doppelkopf:
    return "try for doppelkopf";
    (void)_("AiConfig::Heuristic::try for doppelkopf");
    (void)_("AiConfig::Heuristic::Description::try for doppelkopf");
  case AiconfigHeuristic::play_for_partner_worries:
    return "play for partner worries";
    (void)_("AiConfig::Heuristic::play for partner worries");
    (void)_("AiConfig::Heuristic::Description::play for partner worries");
  case AiconfigHeuristic::partner_backhand_draw_trump:
    return "partner backhand draw trump";
    (void)_("AiConfig::Heuristic::partner backhand draw trump");
    (void)_("AiConfig::Heuristic::Description::partner backhand draw trump");
  case AiconfigHeuristic::draw_trump:
    return "draw trump";
    (void)_("AiConfig::Heuristic::draw trump");
    (void)_("AiConfig::Heuristic::Description::draw trump");
  case AiconfigHeuristic::play_to_jab_later:
    return "play to jab later";
    (void)_("AiConfig::Heuristic::play to jab later");
    (void)_("AiConfig::Heuristic::Description::play to jab later");
  case AiconfigHeuristic::play_highest_color_card_in_game:
    return "play highest color card in game";
    (void)_("AiConfig::Heuristic::play highest color card in game");
    (void)_("AiConfig::Heuristic::Description::play highest color card in game");
  case AiconfigHeuristic::get_trick_for_announcement:
    return "get trick for announcement";
    (void)_("AiConfig::Heuristic::get trick for announcement");
    (void)_("AiConfig::Heuristic::Description::get trick for announcement");
  case AiconfigHeuristic::grab_trick:
    return "grab trick";
    (void)_("AiConfig::Heuristic::grab trick");
    (void)_("AiConfig::Heuristic::Description::grab trick");
  case AiconfigHeuristic::let_trick_pass:
    return "let trick pass";
    (void)_("AiConfig::Heuristic::let trick pass");
    (void)_("AiConfig::Heuristic::Description::let trick pass");

  case AiconfigHeuristic::poverty_special_play_pfund:
    return "poverty: special: play pfund";
    (void)_("AiConfig::Heuristic::poverty: special: play pfund");
    (void)_("AiConfig::Heuristic::Description::poverty: special: play pfund");
  case AiconfigHeuristic::poverty_special_give_no_points:
    return "poverty: special: give no points";
    (void)_("AiConfig::Heuristic::poverty: special: give no points");
    (void)_("AiConfig::Heuristic::Description::poverty: special: give no points");
  case AiconfigHeuristic::poverty_special_offer_pfund:
    return "poverty: special: offer pfund";
    (void)_("AiConfig::Heuristic::poverty: special: offer pfund");
    (void)_("AiConfig::Heuristic::Description::poverty: special: offer pfund");
  case AiconfigHeuristic::poverty_re_trump_color_trick_high:
    return "poverty: re: trump color trick high";
    (void)_("AiConfig::Heuristic::poverty: re: trump color trick high");
    (void)_("AiConfig::Heuristic::Description::poverty: re: trump color trick high");
  case AiconfigHeuristic::poverty_re_play_trump:
    return "poverty: re: play trump";
    (void)_("AiConfig::Heuristic::poverty: re: play trump");
    (void)_("AiConfig::Heuristic::Description::poverty: re: play trump");
  case AiconfigHeuristic::poverty_contra_play_color:
    return "poverty: contra: play color";
    (void)_("AiConfig::Heuristic::poverty: contra: play color");
    (void)_("AiConfig::Heuristic::Description::poverty: contra: play color");
  case AiconfigHeuristic::poverty_contra_trump_color_trick_high:
    return "poverty: contra: trump color trick high";
    (void)_("AiConfig::Heuristic::poverty: contra: trump color trick high");
    (void)_("AiConfig::Heuristic::Description::poverty: contra: trump color trick high");
  case AiconfigHeuristic::poverty_leave_to_partner:
    return "poverty: contra: leave to partner";
    (void)_("AiConfig::Heuristic::poverty: contra: leave to partner");
    (void)_("AiConfig::Heuristic::Description::poverty: contra: leave to partner");
  case AiconfigHeuristic::poverty_overjab_re:
    return "poverty: contra: overjab re";
    (void)_("AiConfig::Heuristic::poverty: contra: overjab re");
    (void)_("AiConfig::Heuristic::Description::poverty: contra: overjab re");
  case AiconfigHeuristic::poverty_best_winning_card:
    return "poverty: best winning card";
    (void)_("AiConfig::Heuristic::poverty: best winning card");
    (void)_("AiConfig::Heuristic::Description::poverty: best winning card");

  case AiconfigHeuristic::play_color_in_solo:
    return "play color in solo";
    (void)_("AiConfig::Heuristic::play color in solo");
    (void)_("AiConfig::Heuristic::Description::play color in solo");
  case AiconfigHeuristic::meatless_playhighestcolor:
    return "meatless: play highest color";
    (void)_("AiConfig::Heuristic::meatless: play highest color");
    (void)_("AiConfig::Heuristic::Description::meatless: play highest color");
  case AiconfigHeuristic::picture_secondbesttrump:
    return "picture: second best trump";
    (void)_("AiConfig::Heuristic::picture: second best trump");
    (void)_("AiConfig::Heuristic::Description::picture: second best trump");
  case AiconfigHeuristic::color_jab_for_ace:
    return "color: jab for ace";
    (void)_("AiConfig::Heuristic::color: jab for ace");
    (void)_("AiConfig::Heuristic::Description::color: jab for ace");
  case AiconfigHeuristic::color_low_high:
    return "color: play low high";
    (void)_("AiConfig::Heuristic::color: play low high");
    (void)_("AiConfig::Heuristic::Description::color: play low high");
  case AiconfigHeuristic::choose_best_card:
    return "choose best card";
    (void)_("AiConfig::Heuristic::choose best card");
    (void)_("AiConfig::Heuristic::Description::choose best card");
  } // switch(heuristic)

  return "";
}

/** @return   whether 'heuristic' is a real heuristic
 **/
bool
is_real(AiconfigHeuristic const heuristic)
{
  switch (heuristic) {
  case AiconfigHeuristic::error:
  case AiconfigHeuristic::no_heuristic:
  case AiconfigHeuristic::manual:
  case AiconfigHeuristic::bug_report:
  case AiconfigHeuristic::only_valid_card:
  case AiconfigHeuristic::choose_best_card:
    return false;
  default:
    return true;
  }
}

/** -> return
 **
 ** @param    h   the heuristic type
 **
 ** @return   whether 'h' is a general heuristic
 **/
/** @return   whether the heuristic is a general heuristic
 **/
bool
is_general(AiconfigHeuristic const heuristic)
{
  return (    is_real(heuristic)
          && !for_solo(heuristic)
          && !for_poverty(heuristic) );
}

/** @return   whether the heuristic was made for a poverty
 **/
bool
for_poverty(AiconfigHeuristic const heuristic)
{
  switch (heuristic) {
  case AiconfigHeuristic::poverty_special_play_pfund:
  case AiconfigHeuristic::poverty_special_give_no_points:
  case AiconfigHeuristic::poverty_special_offer_pfund:
  case AiconfigHeuristic::poverty_re_trump_color_trick_high:
  case AiconfigHeuristic::poverty_re_play_trump:
  case AiconfigHeuristic::poverty_contra_play_color:
  case AiconfigHeuristic::poverty_contra_trump_color_trick_high:
  case AiconfigHeuristic::poverty_leave_to_partner:
  case AiconfigHeuristic::poverty_overjab_re:
  case AiconfigHeuristic::poverty_best_winning_card:
    return true;
  default:
    return false;
  }; // switch(h)
}

/** @return   whether the heuristic was made for a solo
 **/
bool
for_solo(AiconfigHeuristic const heuristic)
{
  return (   for_color_solo(heuristic)
          || for_picture_solo(heuristic)
          || for_meatless_solo(heuristic));
}

/** @return   whether the heuristic was made for a color solo
 **/
bool
for_color_solo(AiconfigHeuristic const heuristic)
{
  switch (heuristic) {
  case AiconfigHeuristic::best_winning:
  case AiconfigHeuristic::color_jab_for_ace:
  case AiconfigHeuristic::color_low_high:
    return true;
  default:
    return false;
  }; // switch(h)
#ifdef WORKAROUND
  // g++ 4.0 -O3
  return false;
#endif
}

/** @return   whether the heuristic was made for a picture solo
 **/
bool
for_picture_solo(AiconfigHeuristic const heuristic)
{
  switch (heuristic) {
  case AiconfigHeuristic::picture_secondbesttrump:
    return true;
  default:
    return false;
  }; // switch(h)
#ifdef WORKAROUND
  // g++ 4.0 -O3
  return false;
#endif
}

/** @return   whether the heuristic was made for a meatless solo
 **/
bool
for_meatless_solo(AiconfigHeuristic const heuristic)
{
  switch (heuristic) {
  case AiconfigHeuristic::meatless_playhighestcolor:
    return true;
  default:
    return false;
  }; // switch(h)
#ifdef WORKAROUND
  // g++ 4.0 -O3
  return false;
#endif
}

/** -> result
 **
 ** @param    name   name of the heuristic
 **
 ** @return   the heuristic according to the name
 **/
AiconfigHeuristic
AiconfigHeuristic_from_name(string const& name)
{
#ifdef WORKAROUND
  // name till 0.7.5
  if (name == "color: choose ace")
    return AiconfigHeuristic::choose_ace;
#endif
#ifdef WORKAROUND
  // name till 0.7.10
  if (name == "color: best winning")
    return AiconfigHeuristic::best_winning;
#endif
  for (auto const h : aiconfig_heuristic_list) {
    if (name == to_string(h)) {
      return h;
    }
  }

  return AiconfigHeuristic::error;
}

/** write the name of the heuristic in the output stream
 **/
ostream& operator<<(ostream& ostr, AiconfigHeuristic const heuristic)
{
  return (ostr << to_string(heuristic));
}

/** @return   translation of the heuristic
 **/
string gettext(AiconfigHeuristic const heuristic)
{
  return gettext("AiConfig::Heuristic::" + to_string(heuristic));
}

/** @return   translation of the heuristic description
 **/
string gettext_description(AiconfigHeuristic const heuristic)
{
  return gettext("AiConfig::Heuristic::Description::" + to_string(heuristic));
}
