/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#include "rating.h"

/**
 ** average rater
 ** Returns the average value of the given values,
 ** skipping the maximal and the minimal value
 **/
class Rating::AveragePhysical : public Rating
{
  public:
    AveragePhysical() : Rating(Type::average_physical) { }
    ~AveragePhysical() override = default;

    // returns the rated value
    int value() const override
    {
      if (this->values.empty())
	return INT_MIN;
      if (this->values.size() == 1)
        return *this->values.begin();
      if (this->values.size() == 2)
        return (*this->values.begin() + *this->values.rbegin()) / 2;

      this->sort();
      int sum = 0;
      for (vector<int>::const_iterator v = this->values.begin() + 1;
           v + 1 != this->values.end();
           ++v)
        sum += *v;

      return sum / ((this->values.size() - 2) / 2);
    } // int value() const
}; // class Rating::AveragePhysical : public Rating
