/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

// included by trickpile.h

#pragma once

class TrickPile;

class TrickPileIterator : public std::iterator<std::output_iterator_tag, Trick> {
  friend class TrickPile;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  TrickPileIterator() = delete;
  TrickPileIterator(TrickPile& tricks, unsigned t);

  public:
  Trick& operator*();
  Trick const& operator*() const;
  Trick* operator->();
  Trick const* operator->() const;
  TrickPileIterator& operator++();
  bool operator!=(TrickPileIterator const& i) const;
  private:
  TrickPile* const tricks_ = nullptr;
  size_t t_ = 0;
}; // TrickPileIterator 

class TrickPileConstIterator : public std::iterator<std::output_iterator_tag, Trick> {
  friend class TrickPile;
  public:
  using iterator_category = std::forward_iterator_tag;
  private:
  TrickPileConstIterator() = delete;
  TrickPileConstIterator(TrickPile const& tricks, unsigned t);

  public:
  TrickPileConstIterator(TrickPileIterator i);
  Trick const& operator*() const;
  Trick const* operator->() const;
  TrickPileConstIterator& operator++();
  bool operator!=(TrickPileConstIterator const& i) const;
  private:
  TrickPile const* const tricks_ = nullptr;
  size_t t_ = 0;
}; // TrickPileConstIterator 
