/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#ifdef USE_SOUND_ALUT

#include "sound.h"

#include <AL/alut.h>

/**
 ** @brief	the sound class using the program 'aplay'
 **
 ** @author	Diether Knof
 **/
class Sound::Alut : public Sound {
  private:
    // number of instances
    static unsigned instances_no;

  public:
    Alut();
    ~Alut() override;

    Alut(Alut const&) = delete;
    Alut& operator=(Alut const&) = delete;

    void play(Position position,
              string const& soundgroup,
              Type const type) override;
    bool playing() const override;

  private:
    void check_current_sound();
    void play_next_sound();

  private:
    AutoDisconnector disconnector_;
    ALuint current_source_ = 0;
    queue<string> file_queue_;
}; // class Alut : public Sound

#endif // #ifdef USE_SOUND_ALUT
