/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "base.h"

#include <gtkmm/dialog.h>
#include <gtkmm/textbuffer.h>

namespace UI_GTKMM_NS {

/**
 ** a dialog only shown on the first run of the program
 **
 ** @todo   when the program first starts let it stay on top (works),
 **         but when the user selects another window do not raise it again
 **/
class FirstRun : public Base, public Gtk::Dialog {
  public:
    FirstRun(Base* parent, string  message);
    ~FirstRun() override;

  private:
    void init();

  private:
    string const message_;

  private: // unused
    FirstRun() = delete;
    FirstRun(FirstRun const&) = delete;
    FirstRun& operator=(FirstRun const&) = delete;
}; // class FirstRun : public Base, public Gtk::Dialog

} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
