/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "base.h"

class Game;
class Trick;

#include <gdk/gdk.h>

namespace UI_GTKMM_NS {
class GameFinished;

/**
 ** window for reviewing the game (trickwise)
 **/
class GameReview : public Base {
  public:
    explicit GameReview(GameFinished* game_finished);
    ~GameReview() override;

    unsigned trickno() const;
    ::Trick const& trick() const;
    bool trick_visible() const;

    void previous_trick();
    void following_trick();
    void set_trickno(unsigned trickno);

    bool key_press(GdkEventKey const* key);

  private:
    unsigned trickno_ = 0;

  private:
    GameReview() = delete;
    GameReview(GameReview const&) = delete;
    GameReview& operator=(GameReview const&) = delete;
}; // class GameReview : public Base

} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
