/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "base.h"

#include "../../utils/version.h"
#include <gtkmm/dialog.h>
#include <gtkmm/textbuffer.h>

namespace UI_GTKMM_NS {

/**
 ** message about a program update
 **/
class ProgramUpdated : public Base, public Gtk::Dialog {
  public:
    ProgramUpdated(Base* parent,
                   Version const& old_version);
    ~ProgramUpdated() override;

  private:
    // reset the ais
    void reset_ais();

  private:
    // the last version
    Version const old_version;

    Glib::RefPtr<Gtk::TextBuffer> text_buffer;

  private: // unused
    ProgramUpdated() = delete;
    ProgramUpdated(ProgramUpdated const&) = delete;
    ProgramUpdated& operator=(ProgramUpdated const&) = delete;
}; // class ProgramUpdated : public Base, public Gtk::Dialog

} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
