/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "table_part.h"
#include "trick_drawing.h"

#include "../../card/trick.h"

namespace UI_GTKMM_NS {

/**
 ** the graphic representation of the current trick
 **/
class Trick : public Table::Part, public TrickDrawing {
public:
  struct Geometry : public Table::Part::Geometry {
    Outline outline() const override;
  }; // struct Geometry
public:
  explicit Trick(Table* table);
  Trick() = delete;
  Trick(Trick const&) = delete;
  Trick& operator=(Trick const&) = delete;

  ~Trick() override;

  bool changed() const override;
  Geometry geometry() const;
  Outline outline() const override;

  void draw(Cairo::RefPtr<::Cairo::Context> cr) override;
  bool mouse_over_cards() const;
private:
  ::Trick trick_drawed_;
}; // class Trick : public TrickDrawing 

} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
