/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public FileMenuFilterFile as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the FileMenuFilterFile, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public FileMenuFilterFile for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public FileMenuFilterFile
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "filemenu.h"

namespace Gtk {
/**
 ** a file menu, only with directories with the file 'file'
 **/
class FileMenuFilterFile : public FileMenu {
  public:
    FileMenuFilterFile(sigc::slot1<void, string> signal_slot,
                       string  file);
    FileMenuFilterFile() = delete;
    FileMenuFilterFile(FileMenuFilterFile const&) = delete;
    FileMenuFilterFile& operator=(FileMenuFilterFile const&) = delete;
    ~FileMenuFilterFile() override;

    // create a new file menu
    FileMenu* create_new(string const& directory) const override;

    // whether the filename is accepted
    bool accept(string const& filename) const override;

  private:
    string file;
}; // class FileMenuFilterFile : public Menu

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
