/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public Rules as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the Rules, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public Rules for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public Rules
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include <gtkmm/box.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>

namespace Gtk {
/**
 ** a spin button with a label
 **/
class LabelEntry : public Box {
  public:
    LabelEntry();
    LabelEntry(Glib::ustring const& text);
    LabelEntry(LabelEntry const&) = delete;
    LabelEntry& operator=(LabelEntry const&) = delete;

    ~LabelEntry() override;

    Label* get_label();
    void set_label(Glib::ustring const& text);

    Entry* get_entry();
    Glib::ustring get_text();
    virtual void set_text(Glib::ustring const& text);

  private:
    Label* label_;
    Entry* entry_;
}; // class LabelEntry : public Box

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
