/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public Rules as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the Rules, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public Rules for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public Rules
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "labelspinbutton.h"
#include <gtkmm/scale.h>

namespace Gtk {
/**
 ** a spin button with a label
 **/
class LabelScaleSpinButton : public LabelSpinButton {
  public:
    LabelScaleSpinButton();
    explicit LabelScaleSpinButton(Glib::ustring const& label);
    LabelScaleSpinButton(LabelScaleSpinButton const&) = delete;
    LabelScaleSpinButton& operator=(LabelScaleSpinButton const&) = delete;

    ~LabelScaleSpinButton() override = default;

    Scale* get_scale();

    void set_range(double min, double max) override;

  private:
    Scale* scale_ = nullptr;
}; // class LabelScaleSpinButton : public LabelSpinButton

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
