/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public PixbufRotations as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the PixbufRotations, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public PixbufRotations for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public PixbufRotations
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "../../../basetypes.h"
#include <gdkmm/pixbuf.h>

namespace Gdk {
/**
 ** a pixmap with rotations (up, down, left, right)
 ** the rotations are created when needed
 **/
class PixbufRotations : public Glib::RefPtr<Pixbuf> {
  public:
    PixbufRotations(string const& filename);
    PixbufRotations(Glib::RefPtr<Pixbuf> pixbuf);
    PixbufRotations() = delete;
    PixbufRotations(PixbufRotations const&) = delete;
    PixbufRotations& operator=(PixbufRotations const&) = delete;
    virtual ~PixbufRotations();

    // pixbuf according to the rotation
    Glib::RefPtr<Pixbuf> operator[](Rotation rotation);

    // width of the pixbuf
    int width(Rotation rotation = Rotation::up) const;
    // height of the pixbuf
    int height(Rotation rotation = Rotation::up) const;

  private:
    Glib::RefPtr<Pixbuf> create_rotation(Rotation rotation);
  private:
    vector<Glib::RefPtr<Pixbuf> > pixbuf;
}; // class PixbufRotations : public Glib::RefPtr<Pixbuf>

} // namespace Gdk

#endif // #ifdef USE_UI_GTKMM
