/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#include "constants.h"

#ifdef USE_UI_TEXT

#include "ui.h"

#include "../../misc/setting.h"
#include "../../misc/translations.h"

namespace UI_TEXT_NS {

/** redraw all (of the playfield)
 **
 ** @todo   all
 **/
void
  UI_Text::redraw_all()
  { 
  } // void UI_Text::redraw_all()

/** update the gametype icon
 **
 ** @todo   all
 **/
void
  UI_Text::gametype_update()
  { 
  } // void UI_Text::gametype_udpate()

/** update the trick
 **
 ** @todo   all
 **/
void
  UI_Text::trick_update()
  { 
  } // void UI_Text::trick_update()

/** update the name of 'player'
 **
 ** @param    player   the player
 **
 ** @todo   all
 **/
void
  UI_Text::name_update(Player const& player)
  {
  } // void UI_Text::name_update(player)

/** update the hand of 'player'
 **
 ** @param    player   the player
 **
 ** @todo   all
 **/
void
  UI_Text::hand_update(Player const& player)
  { 
  } // void UI_Text::hand_update(player)

/** update the trickpile of 'player'
 **
 ** @param    player   the player
 **
 ** @todo   all
 **/
void
  UI_Text::trick_pile_update(Player const& player)
  { 
  } // void UI_Text::trick_pile_udpate(player)

/** update the team icon of 'player'
 **
 ** @param    player   the player
 **
 ** @todo   all
 **/
void
  UI_Text::teaminfo_update(Player const& player)
  { 
  } // void UI_Text::teaminfo_udpate(player)

/** update the announcement icon of 'player'
 **
 ** @param    player   the player
 **
 ** @todo   all
 **/
void
  UI_Text::announcement_update(Player const& player)
  { 
  } // void UI_Text::announcement_udpate(player)

/** update the rule
 **
 ** @param    type      the rule, that has changed
 ** @param    old_value   old value
 **
 ** @todo   all
 **/
void
  UI_Text::rule_update(int const type, void const* const old_value)
  {
  } // void UI_Text::rule_update(int const type, void const* const old_value)

/** show the update
 **
 ** @param    type      the setting, that has changed
 ** @param    old_value   old value
 **/
void
  UI_Text::setting_update(int const type, void const* const old_value)
  {
    if ((type >= Setting::Type::bool_first)
        && (type <= Setting::Type::bool_last))
      this->ostr() << ::translation("Setting")
        << ": " << ::translation(Setting::Type::TypeBool(type))
        << " = " << ::setting(Setting::Type::TypeBool(type))
        << " (" << *(static_cast<bool const* const>(old_value)) << ")"
        << '\n';
    else if ((type >= Setting::Type::unsigned_first)
             && (type <= Setting::Type::unsigned_last))
      this->ostr() << ::translation("Setting")
        << ": " << ::translation(Setting::Type::TypeUnsigned(type))
        << " = " << ::setting(Setting::Type::TypeUnsigned(type))
        << " (" << *(static_cast<unsigned const* const>(old_value)) << ")"
        << '\n';
    else if ((type >= Setting::Type::string_first)
             && (type <= Setting::Type::string_last))
      this->ostr() << ::translation("Setting")
        << ": " << ::translation(Setting::Type::TypeString(type))
        << " = " << ::setting(Setting::Type::TypeString(type))
        << " (" << *(static_cast<string const* const>(old_value)) << ")"
        << '\n';
    else if (type == Setting::Type::cards_order)
      this->ostr() << ::translation("Setting")
        << ": " << ::translation(::name(Setting::Type::TypeCardsOrder(type)))
        << " = " << ::setting(Setting::Type::TypeCardsOrder(type))
        << " (" << *(static_cast<Setting::Type::CardsOrder const* const>(old_value)) << ")"
        << '\n';
  } // void UI_Text::setting_update(int type, void const* old_value)

} // namespace UI_TEXT_NS

#endif // #ifdef USE_UI_TEXT
