/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "../basetypes.h"

#include "ui.h"

/**
 ** a dummy ui class (no user interaction)
 **/
class UI_Dummy : public UI {
  public:
    UI_Dummy();
    UI_Dummy(UI_Dummy const&) = delete;
    UI_Dummy& operator=(UI_Dummy const&) = delete;
    ~UI_Dummy() override = default;

    void party_close() override;

    Reservation get_reservation(Player const& player) override;
    HandCard get_card(Player const& player) override;

    HandCards get_poverty_cards_to_shift(Player& player) override;
    HandCards get_poverty_exchanged_cards(Player& player,
                                          HandCards const& cards) override;
    bool get_poverty_take_accept(Player const& player,
                                 unsigned cardno) override;

    Player const* get_genscher_partner() override;

    void information(string const& message,
                     InformationType type,
                     bool force_show = false) override;
    void error(string const& message) override;
}; // class UI_Dummy : public UI
