/**********************************************************************
 *
 *   Copyright (C) 2001 – 2018 by Diether Knof
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 ********************************************************************/

#pragma once

#include <time.h>
#include <iosfwd>
using std::ostream;

struct Time {
  static Time current();

  Time() = default;
  Time(time_t sec, unsigned msec);
  ~Time() = default;

  // the seconds
  time_t sec = 0;
  // the mili seconds
  unsigned msec = 0;

}; // struct Time

ostream& operator<<(ostream& ostr, Time const& time);
